UNIT mTKugel;

interface

uses       mSuM;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        hatStift : Stift;
        zHMax : Zahl;
        zHMin : Zahl;

     //Objektbeziehungen:
        // hatStift : Stift;

     // Methoden
     private
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure Zeichne;
        function hPosition : Zahl;
     public
        constructor init(px,py:Zahl);
        procedure Bewege;
        procedure merke(pHMin, pHMax : Zahl);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- Loesche (private) -------------------------------------------
procedure TKugel.Loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- Zeichne (private) -------------------------------------------
procedure TKugel.Zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py:Zahl);
begin
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  self.zeichne 
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatStift.bewegeUm(0.1);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > zHMax-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(180);  // nach links
  if self.hPosition < zHMin+12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     self.setzeRichtung(0);    // nach rechts
  self.Zeichne;
end;

//-------- merke (public) ----------------------------------------------
procedure TKugel.merke(pHMin, pHMax : Zahl);
begin
   zHMin := pHMin;
   zHMax := pHMax;
end ;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
